# coding: utf-8

"""
    FastAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from openapi_client.models.endpoint1 import Endpoint1
#from openapi_client.models.metadata_value import MetadataValue
from typing import Optional, Set
from typing_extensions import Self

class Profile(BaseModel):
    """
    Profile
    """ # noqa: E501
    tag: StrictStr
    username: Optional[StrictStr] = None
    secret: Optional[StrictStr] = None
    secret_type: StrictStr
    auth_scheme: Optional[StrictStr] = 'native'
    endpoint: Endpoint1
    metadata: Optional[Dict[str, Union[Dict,List]]] = None
    __properties: ClassVar[List[str]] = ["tag", "username", "secret", "secret_type", "auth_scheme", "endpoint", "metadata"]

    @field_validator('secret_type')
    def secret_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['password', 'ticket', 'token']):
            raise ValueError("must be one of enum values ('password', 'ticket', 'token')")
        return value

    @field_validator('auth_scheme')
    def auth_scheme_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['native', 'pam']):
            raise ValueError("must be one of enum values ('native', 'pam')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Profile from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of endpoint
        if self.endpoint:
            _dict['endpoint'] = self.endpoint.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each value in metadata (dict)
        _field_dict = {}
        if self.metadata:
            for _key_metadata in self.metadata:
                if self.metadata[_key_metadata]:
                    _field_dict[_key_metadata] = self.metadata[_key_metadata]
            _dict['metadata'] = _field_dict
        # set to None if username (nullable) is None
        # and model_fields_set contains the field
        if self.username is None and "username" in self.model_fields_set:
            _dict['username'] = None

        # set to None if secret (nullable) is None
        # and model_fields_set contains the field
        if self.secret is None and "secret" in self.model_fields_set:
            _dict['secret'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Profile from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "tag": obj.get("tag"),
            "username": obj.get("username"),
            "secret": obj.get("secret"),
            "secret_type": obj.get("secret_type"),
            "auth_scheme": obj.get("auth_scheme") if obj.get("auth_scheme") is not None else 'native',
            "endpoint": Endpoint1.from_dict(obj["endpoint"]) if obj.get("endpoint") is not None else None,
            "metadata": obj.get("metadata") if obj.get("metadata") is not None else None
        })
        return _obj


